"""Text splitter implementations."""
from abc import abstractmethod, ABC
from pydantic import BaseModel
from typing import List


class TextSplitter(ABC, BaseModel):
    class Config:
        arbitrary_types_allowed = True

    @abstractmethod
    def split_text(self, text: str) -> List[str]:
        ...


class MetadataAwareTextSplitter(TextSplitter):
    @abstractmethod
    def split_text_metadata_aware(self, text: str, metadata_str: str) -> List[str]:
        ...
